package test;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.AsynchronousSocketChannel;
import java.nio.channels.CompletionHandler;

public class Server1 extends AbstractServer {
   
    public Server1(int serverPort) throws IOException {
        super(serverPort);
    }
    
    public void doAccepting() {
        serverSocketChannel.accept(null, new CompletionHandler<AsynchronousSocketChannel,Object>() {

            @Override
            public void completed(final AsynchronousSocketChannel channel, Object attachment) {
                
                ClientSession session = new ClientSession();
                
                final ByteBuffer buf = ByteBuffer.allocateDirect(256);
                            
                channel.read(buf, session, new CompletionHandler<Integer, ClientSession>() {
           
                    @Override
                    public void completed(Integer len, ClientSession clSession) {

                        if (clSession.handleInput(buf, len)) {
                            channel.read(buf, clSession, this);
                        }
                        else {
                            try {
                                channel.close();
                            } catch (IOException e) { /* ignore */ }
                        }
                    }

                    @Override
                    public void failed(Throwable exc, ClientSession clSession) {
                        System.out.println("client connection socket problem: " + exc);
                        exc.printStackTrace();    

                        clSession.handleFailure();
                        
                        try {
                            channel.close();
                        } catch (IOException e) { /* ignore */ }
                    }
                });
                
                serverSocketChannel.accept(null, this);
            }

            @Override
            public void failed(Throwable exc, Object attachment) {
                System.out.println("server socket problem: " + exc);
                exc.printStackTrace();
                
                serverSocketChannel.accept(null, this);
            }
            
        });
    }
    
}
